"use strict";

var _interopRequireDefault = require("babel-runtime/helpers/interop-require-default")["default"];

exports.__esModule = true;

var _leven = require("leven");

var _leven2 = _interopRequireDefault(_leven);

exports["default"] = function (_ref) {
  var messages = _ref.messages;

  return {
    visitor: {
      ReferencedIdentifier: function ReferencedIdentifier(path) {
        var node = path.node;
        var scope = path.scope;

        var binding = scope.getBinding(node.name);
        if (binding && binding.kind === "type" && !path.parentPath.isFlow()) {
          throw path.buildCodeFrameError(messages.get("undeclaredVariableType", node.name), ReferenceError);
        }

        if (scope.hasBinding(node.name)) return;

        // get the closest declaration to offer as a suggestion
        // the variable name may have just been mistyped

        var bindings = scope.getAllBindings();

        var closest = undefined;
        var shortest = -1;

        for (var _name in bindings) {
          var distance = _leven2["default"](node.name, _name);
          if (distance <= 0 || distance > 3) continue;
          if (distance <= shortest) continue;

          closest = _name;
          shortest = distance;
        }

        var msg = undefined;
        if (closest) {
          msg = messages.get("undeclaredVariableSuggestion", node.name, closest);
        } else {
          msg = messages.get("undeclaredVariable", node.name);
        }

        //

        throw path.buildCodeFrameError(msg, ReferenceError);
      }
    }
  };
};

module.exports = exports["default"];